// SETA43
// http://seta43.hol.es/raardu.html

#include <Wire.h>

#define DEBUG 1


int volumen=8,volumenOld=7;
int frecuencia,frecuenciaOld;

unsigned int z,z1;
byte xfrecu,xfrecuOld;
unsigned int estado[6];


int time3,time2,time1;

// int    RDA5807_adrs=0x10;       // I2C-Address RDA Chip for sequential  Access
// int    RDA5807_adrr=0x11;       // I2C-Address RDA Chip for random      Access
// int    RDA5807_adrt=0x60;       // I2C-Address RDA Chip for TEA5767like Access

char buffer[80];
unsigned int RDS[4];
unsigned char seg_RDS[10];
unsigned char seg_RDS1[64];
char indexRDS1;

char hora,minuto,grupo,versio;
unsigned long julian;

int mezcla;

char entrada[100];
int contador;
boolean stringComplete = true;



void setup() 
{
  Wire.begin();   
  Serial.begin(9600);
  Serial.print("RADIO\n");
  Serial.print("RADIO\n"); 

  WriteReg(0x02,0xC00d); // write 0xC00d into Reg.2 ( soft reset, enable,RDS, )
  WriteReg(0x05,0x84d8);  // write ,0x84d8 into Reg.3 

  // frecuencia inicial
  frecuencia=165; //103.5
  //  frecuencia=26; //89.6

  canal(frecuencia);
  clearRDS;
  time3=time2=time1=100;
}

void loop() 
{
  int i;

  while (Serial.available())
  {
    char inChar = (char)Serial.read(); 
    entrada[contador]=inChar;  
    if (inChar == '\n')
    {
      stringComplete = true;
      entrada[contador]=0;
    } 
    contador++;  
  } 

  if (stringComplete) 
  { 
    if(!strncmp(entrada,"RADIO1=",7))
    {
      Serial.println("OK");
      goto salir0;
    }
    if(!strncmp(entrada,"buscar+",7))
    {  
      Serial.println("buscar+_OK");
      busqueda(0); 
      goto salir0;  
    }
    if(!strncmp(entrada,"buscar-",7))
    {   
      Serial.println("buscar-_OK");
      busqueda(1);
      goto salir0;   
    }
    if(!strncmp(entrada,"volume+",7))
    {  
      Serial.println("volume+_OK");
      volumen++;
      if(volumen>15)volumen=15;  
      goto salir0;
    }
    if(!strncmp(entrada,"volume-",7))
    {   
      Serial.println("volume-_OK");
      volumen--;
      if(volumen<0)volumen=0;   
      goto salir0;
    }
    if(!strncmp(entrada,"ncanal=",7))
    {   
      Serial.print("ncanalOK=");
      strcpy(buffer,entrada+7);
      z=atoi(buffer); 
      Serial.println(z);  
      frecuencia=z;
      goto salir0;
    }
    if(!strncmp(entrada,"volume=",7))
    {   
      Serial.print("volumeOK=");
      strcpy(buffer,entrada+7);
      z=atoi(buffer); 
      Serial.println(z);  
      volumen=z;
      if(volumen>15)volumen=15;
      if(volumen<0)volumen=0;
      goto salir0;
    }  
    Serial.print("ERROR "); 
    Serial.println(entrada);
salir0:
    contador=0;
    stringComplete = false;
  }

  //Cambio de frecuencia
  if( frecuencia!=frecuenciaOld)
  {  
    frecuenciaOld=frecuencia;                        
    Visualizar();
    canal(frecuencia);
    clearRDS();
  }     

  //Cambio de volumen        
  if(volumen!=volumenOld)
  { 
    volumenOld=volumen;
    sprintf(buffer,"Volumen=%02d",volumen); 
    Serial.println(buffer);
    WriteReg(5, 0x84D0 | volumen);
  }       

  delay(1);
  time3--; 
  time2--; 
  time1--;
  if(time2<1)
  {
    Serial.print("__Time2__\n");
    time2=2000;
    Visualizar();
    Serial.print("CODEFRE1=");
    Serial.println((RDS[2]>>8)+875);
    Serial.print("CODEFRE2="); 
    Serial.println(RDS[2]&0xFF+875);
    //NOMBRE__________ 
    Serial.print("RDSDATO0=");
    for (i=0;i<8;i++)
    {  
      if(seg_RDS[i]>20)
        Serial.write(seg_RDS[i]);
      else
        Serial.write(32);
    } 
    Serial.println(""); 
    //TEXTO___________
    Serial.print("RDSDATO2=");
    for (i=0;i<64;i++)
    { 
      if(seg_RDS1[i]>20)
      {
        if(seg_RDS1[i]<0x80)
        {  
          Serial.write(seg_RDS1[i]);
        }
        else
        {
          switch(seg_RDS1[i])
          {
          case 0x8A:
            Serial.write('N');
            break;
          case 0x9A:
            Serial.write('n');
            break;
          case 0x80:
            Serial.write('a');
            break;
          case 0x82:
            Serial.write('e');
            break;
          case 0x84:
            Serial.write('i');
            break;
          case 0x86:
            Serial.write('o');
            break;
          case 0x88:
            Serial.write('u');
            break;
          default: 
            Serial.write('*');
          }
        }
      }
      else
      { 
        Serial.write(32); 
      }
    }                                  
    Serial.println("<-");
    /*
      Serial.print("CODEDATE=");
     sprintf(buffer,"%d  %02d:%02d ",julian ,hora,minuto); 
     Serial.println(buffer); 
     */
  }

  if(time1<1)
  {
    time1=20;
    ReadEstado();       
    //RDS   
    if ((estado[0] & 0x8000)!=0)     get_RDS(); 
  }

  if(time3<1)
  {
    time3=300;     
    //SEÑAL  
    z=estado[1]>>10;  
    sprintf(buffer,"SIGNAL=%02d",z); 
    Serial.println(buffer);
  }

}

//=======FIN=================================


void busqueda(byte direc)
{
  byte i;
  if(!direc) WriteReg(0x02,0xC30d); 
  else  WriteReg(0x02,0xC10d);

  for(i=0;i<10;i++)
  {
    delay(200);      
    ReadEstado();      
    if(estado[0]&0x4000)
    {
      //Serial.println("Emisora encontrada");
      frecuencia=estado[0] & 0x03ff;  
      break;
    }       
  }
}




void Visualizar(void)
{ 
  z=870+frecuencia;
  sprintf(buffer,"Canal=%04i",frecuencia); 
  Serial.println(buffer);  
  sprintf(buffer,"Frecuencia=%04i",z); 
  Serial.println(buffer); 
  if((estado[0] & 0x0400)==0)
    Serial.println("CODESTEREO=0");  
  else
    Serial.println("CODESTEREO=1"); 
  visualPI();
  visualPTY();
}

void canal( int canal)
{

  byte numeroH,numeroL;

  numeroH=  canal>>2;
  numeroL = ((canal&3)<<6 | 0x10); 
  Wire.beginTransmission(0x11);
  Wire.write(0x03);
  Wire.write(numeroH);                     // write frequency into bits 15:6, set tune bit         
  Wire.write(numeroL);
  Wire.endTransmission();
}

//________________________________________________
void visualPI(void)
{

  Serial.print("CODEPAIS="); 
  Serial.println(RDS[0]>>12 & 0X000F);
  Serial.print("CODECOBER="); 
  Serial.println(RDS[0]>>8 & 0X000F);
  Serial.print("CODECODIGO="); 
  Serial.println(RDS[0] & 0X00FF); 
}
void visualPTY(void)
{
  Serial.print("CODEPTY=");  
  Serial.println(RDS[1]>>5 & 0X001F);     
  sprintf(buffer,"%02d",RDS[1]>>5 & 0X001F);
  Serial.print("CODETIPO="); 
  Serial.println(buffer);  
}


void clearRDS(void)
{       
  for (z=0;z<8;z++) {    
    seg_RDS[z]=32;  
  } 
  for (z=0;z<64;z++) seg_RDS1[z]=32;   
}

void get_RDS()
{    
  int i;

  ReadW();      
  grupo=(RDS[1]>>12)&0xf;
  if(RDS[1]&0x0800) 
    versio=1; 
  else 
    versio=0;  //Version A=0  Version B=1   

  if(versio==0)
  {           
    //   sprintf(buffer,"CODEVersion=%d \nCODEGrupo=%02d",versio,grupo); 
    //   Serial.println(buffer);

    switch(grupo)
    {
    case 0:              
      i=(RDS[1] & 3) <<1;
      seg_RDS[i]=(RDS[3]>>8);       
      seg_RDS[i+1]=(RDS[3]&0xFF);
      break;
    case 2:
      i=(RDS[1] & 15) <<2;              
      seg_RDS1[i]=(RDS[2]>>8);       
      seg_RDS1[i+1]=(RDS[2]&0xFF);
      seg_RDS1[i+2]=(RDS[3]>>8);       
      seg_RDS1[i+3]=(RDS[3]&0xFF);    
      break;
    case 4:             
      i=RDS[3]& 0x003f;
      minuto=(RDS[3]>>6)& 0x003f;
      hora=(RDS[3]>>12)& 0x000f;
      if(RDS[2]&1) hora+=16;
      hora+=i;        
      z=RDS[2]>>1;
      julian=z;

      if(RDS[1]&1) julian+=32768;
      if(RDS[1]&2) julian+=65536;      
      break;
    default:   
      ;        
    }                        
  }                   
} 







//________________________ 
//RDA5807_adrr=0x11;       
// I2C-Address RDA Chip for random      Access
void WriteReg(byte reg,unsigned int valor)
{
  Wire.beginTransmission(0x11);
  Wire.write(reg); 
  Wire.write(valor >> 8); 
  Wire.write(valor & 0xFF);
  Wire.endTransmission();
  //delay(50);
}

//RDA5807_adrs=0x10;
// I2C-Address RDA Chip for sequential  Access
int ReadEstado()
{
  Wire.requestFrom(0x10, 12); 
  for (int i=0; i<6; i++) {  
    estado[i] = 256*Wire.read ()+Wire.read();   
  }
  Wire.endTransmission();

}

//READ RDS  Direccion 0x11 for random access
void ReadW()
{
  Wire.beginTransmission(0x11);            // Device 0x11 for random access
  Wire.write(0x0C);                                // Start at Register 0x0C
  Wire.endTransmission(0);                         // restart condition
  Wire.requestFrom(0x11,8, 1);       // Retransmit device address with READ, followed by 8 bytes
  for (int i=0; i<4; i++) {
    RDS[i]=256*Wire.read()+Wire.read();
  }        // Read Data into Array of Unsigned Ints
  Wire.endTransmission();                  
} 




